SellOMatic_Destroy = LibStub("AceAddon-3.0"):NewAddon("SellOMatic_Destroy", "AceEvent-3.0", "AceConsole-3.0");
local SellOMatic = _G.SellOMatic;
local item_tooltip = LibStub("LibGratuity-3.0");
local L = LibStub("AceLocale-3.0"):GetLocale("SellOMatic");

local function getOption(info)
	return (info.arg and SellOMatic.db.profile[info.arg] or SellOMatic.db.profile[info[#info]]);
end;

local function setOption(info, value)
	local key = info.arg or info[#info];
	SellOMatic.db.profile[key] = value;
end;

local destroy_options = {
	type = "group",
	name = L["Destroy Options"],
	args = {
--		destroy_junk = {
--			name = "Destroy junk",
--			order = 1,
--			type = "execute",
--			func = "CallDestroyJunk",
--			image = "Interface\\Icons\\Ability_Warrior_Devastate"
--		},
--		destroy_x_junk = {
--			name = "Destroy X junk",
--			order = 2,
--			type = "execute",
--			func = "CallGiveMeNum",
--		},
--		destroy_x = {
--			name = "X",
--			desc = "Number of items to destroy",
--			order = 3,
--			type = "range",
--			min = 0,
--			max = 20,
--			step = 1,
--			get = getOption,
--			set = setOption,
--		},
	},
}

local destroy_list,item_count;

function SellOMatic_Destroy:OnInitialize()
	LibStub("AceConfig-3.0"):RegisterOptionsTable("SellOMatic_Destroy", destroy_options);
	LibStub("AceConfigDialog-3.0"):AddToBlizOptions("SellOMatic_Destroy", "Destroy Options", "Sell-O-Matic");
end;

function SellOMatic_Destroy:OnEnable()
	destroy_list = {};
	item_count = 0;
end;

function SellOMatic:DestroyJunk()
	SellOMatic_Destroy:FindJunk();
	SellOMatic_Destroy:DestroyJunk();
	SellOMatic_Destroy:ClearJunkList();
end;

function SellOMatic_Destroy:FindJunk()
	local bag, slot, name, itemName, itemRarity, itemSellPrice;
	for bag = 0,4,1 do
		for slot = 1, GetContainerNumSlots(bag), 1 do
			name = GetContainerItemLink(bag,slot);
			if name ~= nil then
				itemName, _, itemRarity, _, _, _, _, itemStackCount, _, _, itemSellPrice = GetItemInfo(name);
				if itemRarity == 0 then
					if itemStackCount > 1 then
						itemSellPrice = itemSellPrice * GetItemCount(itemName);
					end;
					SellOMatic_Destroy:SetJunkList(itemName,itemSellPrice);
				end;
			end;
		end;
	end;
end;

function SellOMatic_Destroy:DestroyJunk()
	local bag, slot, name, itemName, itemLink, itemRarity;
	local num = 0;
	for bag = 0,4,1 do
		for slot = 1, GetContainerNumSlots(bag), 1 do
			name = GetContainerItemLink(bag,slot);
			if name ~= nil then
				itemName, itemLink, itemRarity = GetItemInfo(name);
				if itemRarity == 0 then
					if SellOMatic_Destroy:CheckJunkList(itemName) then
						SellOMatic:Print(L["Destroying:"].." "..itemName);
						num = num + 1;
					end;
				end;
			end;
		end;
	end;
	SellOMatic:Print(num.." "..L["item(s) destroyed"]);
end;

function SellOMatic_Destroy:CheckJunkList(item)
	local i;
	for i=1, #destroy_list, 1 do
		if destroy_list[i][1] == item then
			return 1;
		end;
	end;
	return 0;
end;

function SellOMatic_Destroy:ShortJunk()
	local itemSellPriceX,itemSellPriceY,x,y;
	local z = { "", 0 };
	for x=1, #destroy_list-1, 1 do
		for y=x+1, #destroy_list, 1 do
			if destroy_list[x][2] > destroy_list[y][2] then
				z = destroy_list[x];
				destroy_list[x] = destroy_list[y];
				destroy_list[y] = z;
			end;
		end;
	end;
end;

function SellOMatic_Destroy:DestroyItem(item)
	local bag, slot, name, itemName;
	local found = 0;
	for bag = 0,4,1 do
		for slot = 1, GetContainerNumSlots(bag), 1 do
			if found == 0 then
				name = GetContainerItemLink(bag,slot);
				if name ~= nil then
					itemName = GetItemInfo(name);
					if item == itemName then
						found = 1;
						SellOMatic:Print(L["Destroying:"].." "..item);
					end;
				end;
			end;
		end;
	end;
end;

function SellOMatic:DestroyXJunk(num)
	local x;
	SellOMatic_Destroy:FindJunk();
	SellOMatic_Destroy:ShortJunk();
	num = tonumber(num);
	if num > #destroy_list then num = #destroy_list end;
	for x=1, num, 1 do
		SellOMatic_Destroy:DestroyItem(destroy_list[x][1]);
	end;
	SellOMatic_Destroy:ClearJunkList();
	SellOMatic:Print(num.." "..L["item(s) destroyed"]);
end;

function SellOMatic_Destroy:SetJunkList(item,price)
	destroy_list[#destroy_list+1] = {item,price};
end;

function SellOMatic_Destroy:GetJunkList()
	local i;
	for i=1, #destroy_list, 1 do
		SellOMatic:Print(destroy_list[i][1]);
	end;
end;

function SellOMatic_Destroy:ClearJunkList()
	destroy_list = {};
end;

function SellOMatic:GetItemCount()
	return item_count;
end;


